package it.cs.android1111;


import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import java.io.DataInputStream;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

public class SocketAndroidExampleActivity extends Activity {
    /** Called when the activity is first created. */
	private static final int STATUS_UPDATE = 0;
	private static final int DATA_UPDATE = 1;
	
	private String serverHostName = new String("130.136.37.210");
	private TextView textView;
	private TextView textData;
	private Button sendRequest;
	private Handler myHandler;
	
    @Override 
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main);
        textView=(TextView)findViewById(R.id.textView1);
        textData=(TextView)findViewById(R.id.textView2);
        sendRequest=(Button)findViewById(R.id.button1);
        textView.setText("Service Disconnected ... ");
        myHandler = new Handler() {
            
        	@Override
        	public void handleMessage(Message msg) {
        		switch(msg.what) {
        			case STATUS_UPDATE:
        				textView.setText((String) msg.obj);
        				break;
        			case DATA_UPDATE:
        				textData.setText((String)msg.obj);
        				sendRequest.setEnabled(true);
        				break;
        		}
        		
        	}
        };
    }
    
    
    public void connectAction(View v) {
    	sendRequest.setEnabled(false);
    	textView.setText("Service Connection Attempt ... ");
    	MyThread thread=new MyThread(serverHostName);
    	thread.start();
    }
    
    
    class MyThread extends Thread {
    	
    	
		String server;
    	
    	public MyThread(String hostName) {
    		server=hostName;
    	}
    	
    	public void run() {
    		try {
				Socket socket=new Socket(server,10000);
				Message messageToSend = myHandler.obtainMessage();
				messageToSend.what=STATUS_UPDATE;
				messageToSend.obj = "Connection Enstablished";
				myHandler.sendMessage(messageToSend);
				
				DataInputStream inputStream=new DataInputStream(socket.getInputStream());
				double val=inputStream.readDouble();
				messageToSend = myHandler.obtainMessage();
				messageToSend.what=DATA_UPDATE;
				String msg="Value received "+val;
				messageToSend.obj = msg;
			
				myHandler.sendMessage(messageToSend);
				inputStream.close();
				socket.close();
				
			} catch (UnknownHostException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    		
    	}
    }
}